vexalarm = {}
vexalarm.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexalarm.AceConfig = LibStub("AceConfig-3.0", true)
vexalarm.AceConsole= LibStub("AceConsole-3.0", true)
vexalarm.LSM = LibStub("LibSharedMedia-3.0", true)
vexalarm.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true)

vexalarm.infight = false

vexalarm.debug = false
vexalarm.debugPrintouts = 0

vexalarm.wrongspells = {}

vexalarm.lastSpell={}
vexalarm.lastSpellRW={}

vexalarm.proclaims = {}
vexalarm.proclaimPlaces = {}
vexalarm.totemsPlaced = {}
vexalarm.totemsPlaced_RW = {}

vexalarm.incomeMsgs = {}
vexalarm.incomeSpellProfiles = {}
vexalarm.sentMsgs = {}
vexalarm.SendSuccess = false

vexalarm.defaults = {}
vexalarm.loader = {}
vexalarm.initialize = {}
vexalarm.colorize = {}
vexalarm.frames = {}
vexalarm.frames.createdFrames = {}
vexalarm.lib = {}
vexalarm.warning = {}
vexalarm.rw = {}
vexalarm.scanTool = {}
vexalarm.testmode = {}
vexalarm.testmode.activated = false
vexalarm.testmode.recolor = false
vexalarm.totem = {}
vexalarm.options = {}
vexalarm.options.globals = {}
vexalarm.options.frame = {}
vexalarm.options.frame.content = {}
vexalarm.options.frame.messages = {}
vexalarm.options.frame.settings = {}
vexalarm.options.main = {}
vexalarm.options.profiles = {}
vexalarm.options.rw = {}
vexalarm.options.rw.content = {}
vexalarm.options.rw.messages = {}
vexalarm.options.rw.settings = {}
vexalarm.options.spells = {}
vexalarm.options.spells.profiles = {}
vexalarm.options.spells.profiles.incSP = {}
vexalarm.options.spells.settings = {}
vexalarm.options.spellwindow = {}
vexalarm.options.tagWindow = {}
vexalarm.options.general = {}

function vexalarm_onEvent(self, event, ...)
	if event == "PLAYER_LOGIN" then
		vexalarm.initialize.core()
	elseif event == "PLAYER_REGEN_DISABLED" then
		vexalarm.infight = true
		vexalarm.warning.checkShow()
	elseif event == "PLAYER_REGEN_ENABLED" then
		vexalarm.infight = false
		vexalarm.warning.checkShow()
	elseif event == "CHAT_MSG_ADDON" then
		if select(4, ...) ~= select(1, UnitName("player")) then
			local prefix = select(1, ...)
			local msg = select(2, ...)
			local sender = select(4, ...)
			if prefix == "VEXALARM_SP" then
				vexalarm.options.spells.profiles.incSP.record(msg, sender)
			elseif prefix == "VEXALARM_SP_RE" then
				vexalarm.options.spells.profiles.incSP.re(msg, sender)
			end
		end
	elseif event == "COMBAT_LOG_EVENT_UNFILTERED" then
		if vexalarm_SV_profileData[vexalarm_SV_data["profile"]]["data"]["enableAddon"] then
			local eventchar  = select(2, ...)
			local legal_eventchars = {
				"SPELL_AURA_APPLIED",
				"SPELL_CAST_SUCCESS",
				"SPELL_AURA_REMOVED",
				"SPELL_SUMMON",
				"SPELL_RESURRECT",
				}
				
			local accept_event = false
			for i,v in ipairs(legal_eventchars) do
				if eventchar == v then
					accept_event = true
				end
			end
			
			if accept_event then
				local caster = select(5, ...)
				local spellid = select(12, ...)
				local spellname = select(13, ...)
				local target = select(9, ...)
				local guid = select(4, ...)
				local status = eventchar == "SPELL_AURA_APPLIED" or eventchar == "SPELL_CAST_SUCCESS" or eventchar == "SPELL_SUMMON" or eventchar == "SPELL_RESURRECT"
							
							
				-- DEBUG
				if vexalarm.debug and caster==select(1, UnitName("player")) then
					if vexdebugs.print ~= nil then
						vexalarm.debugPrintouts = vexalarm.debugPrintouts + 1
						print("====|CFFFF7D0AVex Alarm|r - Debug Output Nr: "..vexalarm.debugPrintouts)
						vexdebugs.print(eventchar,"eventChar")
						if vexalarm.defaults.spells[tostring(spellid)] ~= nil then
							vexdebugs.print("spell", {spellid,spellname,"registered"})
						else
							vexdebugs.print("spell", {spellid,spellname,"NOT registered"})
						end
						print("====")
					end
				end
				
				vexalarm.warning.handler(spellname, spellid, caster, target, status, eventchar, guid)
				vexalarm.rw.handler(spellname, spellid, caster, target, status, eventchar, guid)
			elseif eventchar == "UNIT_DESTROYED" then
				vexalarm.totem.cleanRegistry()
				vexalarm.totem.inactiveHandler(select(9, ...))
			end
		end
	end
end