function vexalarm.options.spells.settings.panel()
	local orderStartvalue = 0
	local printableClassnames = {"DeathKnight", "Druid", "Hunter", "Mage", "Monk", "Paladin", "Priest", "Rogue", "Shaman", "Warlock", "Warrior", "no class"}
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local rolenames = {"all", "tank", "heal", "dd", "no role"}
	local enable = {
		{"+", "enable", true},
		{"-", "disable", false}}
	local definitiontexts = {
		"Buffs that have a single target",
		"Buffs that have no target and are mostly casted on yourself",
		"Buffs that effect multiple targets",
		"Casts that have a target",
		"Casts that have no target and are mostly casted on yourself"}
	local rank = 0
	local spelltypes = {"buffWtarget", "buffWOtarget", "grpbuff", "castWtarget", "castWOtarget"}
	
	if vexalarm.options.spells.settings.SP == "" then
		vexalarm.options.spells.settings.SP  = vexalarm.options.spells.settings.getFirstSP()
	end
	
	local options = {
		type = "group",
		args = {
			eventtypegrp = {
				name = "Filter",
				type="group", order= 2, dialogInline = true,
				args = {
					classes = {
						name = "Class",
						order = 1, type ="select", width="half",
						values = {
							[1] = "General",
							[2] = "|CFF"..vexalarm.colorize.getHexClassColor("DEATHKNIGHT").."DK|r",
							[3] = "|CFF"..vexalarm.colorize.getHexClassColor("DRUID").."Druid|r",
							[4] = "|CFF"..vexalarm.colorize.getHexClassColor("HUNTER").."Hunter|r",
							[5] = "|CFF"..vexalarm.colorize.getHexClassColor("MAGE").."Mage|r",
							[6] = "|CFF"..vexalarm.colorize.getHexClassColor("MONK").."Monk|r",
							[7] = "|CFF"..vexalarm.colorize.getHexClassColor("PALADIN").."Paladin|r",
							[8] = "|CFF"..vexalarm.colorize.getHexClassColor("PRIEST").."Priest|r",
							[9] = "|CFF"..vexalarm.colorize.getHexClassColor("ROGUE").."Rogue|r",
							[10] = "|CFF"..vexalarm.colorize.getHexClassColor("SHAMAN").."Shaman|r",
							[11] = "|CFF"..vexalarm.colorize.getHexClassColor("WARLOCK").."Warlock|r",
							[12] = "|CFF"..vexalarm.colorize.getHexClassColor("WARRIOR").."Warrior|r"},
						set = function(info,key) vexalarm.options.spells.settings.setClassFilter(key) vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.settings.getClassFilter() end,
						},
					name = {
						name = "Name",
						order=3, type = "input", multiline = false, width="half",
						set = function(info,val) vexalarm.options.spells.settings.name = val vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.settings.name end
						},
					spells = {
						name = "Spells to adjust:",
						order =11, type ="select", width="normal",
						values = vexalarm.options.spells.profiles.getList(true),
						set = function(info,key) vexalarm.options.spells.settings.SP=key vexalarm.options.spells.profiles.name=key vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.settings.SP end,
						},	
					data = {
						name = "Data to adjust:",
						order =12, type ="select", width="normal",
						values = {["roles"] = "roles", ["behaviour"] = "tracking behaviour"},
						set = function(info,key) vexalarm.options.spells.settings.dataToAdjust=key vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.settings.dataToAdjust end,
						},	
					}
				}
			}
		}
	
	
	if vexalarm.options.spells.settings.SP ~= "" then
		-- +/- buttons
		orderStartvalue = 20
		if vexalarm.options.spells.settings.dataToAdjust == "roles" then
			local optiongrp = {
				name = "Toggle Settings", type = "group", dialogInline = true, args = {}, order=10,
				}
			local role = 0
			for i=1,5 do
				for j=1,2 do
					rank = orderStartvalue+j*10+i
					if i == 1 then 	role = nil		
					else 			role = i-1 end
					optiongrp.args[tostring(vexalarm_optionTab_Spells_eventType).."_"..enable[j][2].."_role_"..tostring(i)] = vexalarm.options.spells.settings.createButton(rolenames[i], enable[j], role, rank)
				end
			end
			--optiongrp.args["spacestring"] = {name=" ", fontSize="large", type="description", order=36, width="half"}
			options.args["buttons"] = optiongrp
		end
		
		
		--SPELLS
		orderStartvalue = 100
		local spellrank = 0
		local spelllist = vexalarm.options.spells.settings.getListSorted(classnames[vexalarm.options.spells.settings.class])
		local spells = { name = printableClassnames[vexalarm.options.spells.settings.class], type = "group", dialogInline = true, args = {}, order=orderStartvalue}
		for j in ipairs(spelllist) do
			local key = spelllist[j][2]
			spellrank = spellrank + 1
			rank = (spellrank*20)+orderStartvalue
			
			spells.args[tostring(rank)] = vexalarm.options.spells.settings.createSpellButton(key, rank, printableClassnames[vexalarm.options.spells.settings.class], classnames[vexalarm.options.spells.settings.class])
			-- spells.args[tostring(rank+1)] = {name=" ", fontSize="large", type="description", order=rank+1, width="double"}
			if vexalarm.options.spells.settings.dataToAdjust == "roles" then
				for z=1,4 do
					spells.args[tostring(rank+z+3)] = vexalarm.options.spells.settings.createToggle(rolenames[z+1], key, z, rank+z+3)
				end
			elseif vexalarm.options.spells.settings.dataToAdjust == "behaviour" then
				spells.args[tostring(rank+1)] = vexalarm.options.spells.settings.createToggleTarget(key,rank+1)
				spells.args[tostring(rank+2)] = vexalarm.options.spells.settings.createToggleTrackBuff(key,rank+2)
				spells.args[tostring(rank+3)] = vexalarm.options.spells.settings.createToggleSelfcastOnly(key,rank+3)
			end
			if j ~= #spelllist then spells.args[tostring(rank+10)] = {name = " ", type="description", order=rank+10, width="full"} end
		end
		options.args["spells"..vexalarm.options.spells.settings.class] = spells
	end
	return options
end
